using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using System.Linq;
using Crestron;
using Crestron.Logos.SplusLibrary;
using Crestron.Logos.SplusObjects;
using Crestron.SimplSharp;

namespace UserModule_KLIPSCH_KDA
{
    public class UserModuleClass_KLIPSCH_KDA : SplusObject
    {
        static CCriticalSection g_criticalSection = new CCriticalSection();
        
        
        
        Crestron.Logos.SplusObjects.DigitalInput ENABLE;
        Crestron.Logos.SplusObjects.DigitalInput REFRESH;
        Crestron.Logos.SplusObjects.DigitalInput LED_FLASH;
        InOutArray<Crestron.Logos.SplusObjects.DigitalInput> MUTE;
        InOutArray<Crestron.Logos.SplusObjects.AnalogInput> CHANNEL;
        InOutArray<Crestron.Logos.SplusObjects.AnalogInput> VOLUME;
        Crestron.Logos.SplusObjects.DigitalOutput ENABLED;
        Crestron.Logos.SplusObjects.DigitalOutput REFRESHING;
        Crestron.Logos.SplusObjects.DigitalOutput LED_FLASH_FB;
        InOutArray<Crestron.Logos.SplusObjects.DigitalOutput> MUTE_FB;
        InOutArray<Crestron.Logos.SplusObjects.AnalogOutput> CHANNEL_FB;
        InOutArray<Crestron.Logos.SplusObjects.AnalogOutput> VOLUME_FB;
        InOutArray<Crestron.Logos.SplusObjects.StringOutput> VOLUME__DOLLAR___FB;
        SplusUdpSocket KDA;
        UShortParameter PORT;
        UShortParameter RANGE;
        StringParameter IPADDRESS;
        CrestronString [] INPUTS__DOLLAR__;
        private void PARSEINPUT (  SplusExecutionContext __context__, ushort CH , CrestronString PARAM__DOLLAR__ ) 
            { 
            ushort I = 0;
            
            
            __context__.SourceCodeLine = 139;
            Trace( "parsing input change on channel {0:d} with param: {1}", (ushort)CH, PARAM__DOLLAR__ ) ; 
            __context__.SourceCodeLine = 141;
            ushort __FN_FORSTART_VAL__1 = (ushort) ( 1 ) ;
            ushort __FN_FOREND_VAL__1 = (ushort)12; 
            int __FN_FORSTEP_VAL__1 = (int)1; 
            for ( I  = __FN_FORSTART_VAL__1; (__FN_FORSTEP_VAL__1 > 0)  ? ( (I  >= __FN_FORSTART_VAL__1) && (I  <= __FN_FOREND_VAL__1) ) : ( (I  <= __FN_FORSTART_VAL__1) && (I  >= __FN_FOREND_VAL__1) ) ; I  += (ushort)__FN_FORSTEP_VAL__1) 
                { 
                __context__.SourceCodeLine = 142;
                if ( Functions.TestForTrue  ( ( Functions.BoolToInt (INPUTS__DOLLAR__[ I ] == PARAM__DOLLAR__))  ) ) 
                    {
                    __context__.SourceCodeLine = 142;
                    CHANNEL_FB [ CH]  .Value = (ushort) ( I ) ; 
                    }
                
                __context__.SourceCodeLine = 141;
                } 
            
            
            }
            
        private void PARSEVOLUME (  SplusExecutionContext __context__, ushort CH , CrestronString PARAM__DOLLAR__ ) 
            { 
            ushort VALUE = 0;
            
            CrestronString SIGN__DOLLAR__;
            SIGN__DOLLAR__  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1, this );
            
            
            __context__.SourceCodeLine = 150;
            Trace( "parsing volume change on channel {0:d} with param: {1}", (ushort)CH, PARAM__DOLLAR__ ) ; 
            __context__.SourceCodeLine = 151;
            VALUE = (ushort) ( (40 - Functions.Atoi( PARAM__DOLLAR__ )) ) ; 
            __context__.SourceCodeLine = 153;
            VOLUME_FB [ CH]  .Value = (ushort) ( ((VALUE * 65535) / 40) ) ; 
            __context__.SourceCodeLine = 154;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (Functions.Atoi( PARAM__DOLLAR__ ) == 0))  ) ) 
                {
                __context__.SourceCodeLine = 154;
                SIGN__DOLLAR__  .UpdateValue ( " "  ) ; 
                }
            
            else 
                {
                __context__.SourceCodeLine = 155;
                SIGN__DOLLAR__  .UpdateValue ( "-"  ) ; 
                }
            
            __context__.SourceCodeLine = 156;
            MakeString ( VOLUME__DOLLAR___FB [ CH] , "{0}{1:d2} dB", SIGN__DOLLAR__ , (short)Functions.Atoi( PARAM__DOLLAR__ )) ; 
            
            }
            
        private CrestronString CONVERTVOLUME (  SplusExecutionContext __context__, ushort VOL ) 
            { 
            short SCALED_VOLUME = 0;
            short TEMP = 0;
            
            CrestronString VOLUME__DOLLAR__;
            VOLUME__DOLLAR__  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 32, this );
            
            
            __context__.SourceCodeLine = 163;
            TEMP = (short) ( ((VOL / 100) * Functions.ToSignedInteger( -( 40 ) )) ) ; 
            __context__.SourceCodeLine = 164;
            SCALED_VOLUME = (short) ( (TEMP / 655) ) ; 
            __context__.SourceCodeLine = 165;
            Trace( "scaling volume to {0:d} (range is {1:d})", (short)(SCALED_VOLUME + RANGE  .Value), (short)RANGE  .Value) ; 
            __context__.SourceCodeLine = 167;
            MakeString ( VOLUME__DOLLAR__ , "-{0:d2} dB", (short)(SCALED_VOLUME + RANGE  .Value)) ; 
            __context__.SourceCodeLine = 168;
            return ( VOLUME__DOLLAR__ ) ; 
            
            }
            
        private void PARSEMUTE (  SplusExecutionContext __context__, ushort CH , CrestronString PARAM__DOLLAR__ ) 
            { 
            
            __context__.SourceCodeLine = 173;
            Trace( "parsing mute change on channel {0:d} with param: {1}", (ushort)CH, PARAM__DOLLAR__ ) ; 
            __context__.SourceCodeLine = 174;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (PARAM__DOLLAR__ == "ON"))  ) ) 
                { 
                __context__.SourceCodeLine = 175;
                MUTE_FB [ CH]  .Value = (ushort) ( 1 ) ; 
                } 
            
            else 
                { 
                __context__.SourceCodeLine = 177;
                MUTE_FB [ CH]  .Value = (ushort) ( 0 ) ; 
                } 
            
            
            }
            
        private ushort SENDCOMMAND (  SplusExecutionContext __context__, CrestronString CMD__DOLLAR__ ) 
            { 
            short STATUS = 0;
            
            CrestronString TX__DOLLAR__;
            TX__DOLLAR__  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 32, this );
            
            
            __context__.SourceCodeLine = 186;
            MakeString ( TX__DOLLAR__ , "{0}\r", CMD__DOLLAR__ ) ; 
            __context__.SourceCodeLine = 187;
            Trace( "sending: {0}", TX__DOLLAR__ ) ; 
            __context__.SourceCodeLine = 188;
            STATUS = (short) ( Functions.SocketSend( KDA , TX__DOLLAR__ ) ) ; 
            __context__.SourceCodeLine = 190;
            Functions.Delay (  (int) ( 10 ) ) ; 
            __context__.SourceCodeLine = 192;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( STATUS < 0 ))  ) ) 
                { 
                __context__.SourceCodeLine = 193;
                Trace( "Error Sending to KDA: {0:d}\r\n", (short)STATUS) ; 
                __context__.SourceCodeLine = 194;
                return (ushort)( 1) ; 
                } 
            
            else 
                { 
                __context__.SourceCodeLine = 196;
                return (ushort)( 0) ; 
                } 
            
            
            return 0; // default return value (none specified in module)
            }
            
        private void GETSTATUS (  SplusExecutionContext __context__ ) 
            { 
            
            __context__.SourceCodeLine = 201;
            REFRESHING  .Value = (ushort) ( 1 ) ; 
            __context__.SourceCodeLine = 202;
            SENDCOMMAND (  __context__ , "INP CH1?") ; 
            __context__.SourceCodeLine = 203;
            SENDCOMMAND (  __context__ , "INP CH2?") ; 
            __context__.SourceCodeLine = 204;
            SENDCOMMAND (  __context__ , "INP CH3?") ; 
            __context__.SourceCodeLine = 205;
            SENDCOMMAND (  __context__ , "INP CH4?") ; 
            __context__.SourceCodeLine = 207;
            SENDCOMMAND (  __context__ , "VOL CH1?") ; 
            __context__.SourceCodeLine = 208;
            SENDCOMMAND (  __context__ , "VOL CH2?") ; 
            __context__.SourceCodeLine = 209;
            SENDCOMMAND (  __context__ , "VOL CH3?") ; 
            __context__.SourceCodeLine = 210;
            SENDCOMMAND (  __context__ , "VOL CH4?") ; 
            __context__.SourceCodeLine = 212;
            SENDCOMMAND (  __context__ , "MUTE CH1?") ; 
            __context__.SourceCodeLine = 213;
            SENDCOMMAND (  __context__ , "MUTE CH2?") ; 
            __context__.SourceCodeLine = 214;
            SENDCOMMAND (  __context__ , "MUTE CH3?") ; 
            __context__.SourceCodeLine = 215;
            SENDCOMMAND (  __context__ , "MUTE CH4?") ; 
            __context__.SourceCodeLine = 216;
            REFRESHING  .Value = (ushort) ( 0 ) ; 
            
            }
            
        object ENABLE_OnPush_0 ( Object __EventInfo__ )
        
            { 
            Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
            try
            {
                SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
                short STATUS = 0;
                
                
                __context__.SourceCodeLine = 226;
                STATUS = (short) ( Functions.SocketUDP_Enable( KDA , IPADDRESS  , (ushort)( PORT  .Value ) ) ) ; 
                __context__.SourceCodeLine = 227;
                Trace( "enabling the UDP connection to the KDA ({0:d})", (ushort)STATUS) ; 
                __context__.SourceCodeLine = 229;
                if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( STATUS < 0 ))  ) ) 
                    { 
                    __context__.SourceCodeLine = 230;
                    ENABLED  .Value = (ushort) ( 0 ) ; 
                    __context__.SourceCodeLine = 231;
                    Trace( "Error listening to {0} on port  {1:d}", IPADDRESS , (short)PORT  .Value) ; 
                    } 
                
                else 
                    { 
                    __context__.SourceCodeLine = 234;
                    ENABLED  .Value = (ushort) ( 1 ) ; 
                    __context__.SourceCodeLine = 235;
                    GETSTATUS (  __context__  ) ; 
                    } 
                
                
                
            }
            catch(Exception e) { ObjectCatchHandler(e); }
            finally { ObjectFinallyHandler( __SignalEventArg__ ); }
            return this;
            
        }
        
    object ENABLE_OnRelease_1 ( Object __EventInfo__ )
    
        { 
        Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
        try
        {
            SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
            short STATUS = 0;
            
            
            __context__.SourceCodeLine = 242;
            STATUS = (short) ( Functions.SocketUDP_Disable( KDA ) ) ; 
            __context__.SourceCodeLine = 243;
            Trace( "disabling the UDP connection to the KDA ({0:d})", (ushort)STATUS) ; 
            __context__.SourceCodeLine = 245;
            ENABLED  .Value = (ushort) ( 0 ) ; 
            __context__.SourceCodeLine = 246;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( STATUS < 0 ))  ) ) 
                {
                __context__.SourceCodeLine = 247;
                Trace( "Error doscinnecting from port {0:d}", (short)PORT  .Value) ; 
                }
            
            
            
        }
        catch(Exception e) { ObjectCatchHandler(e); }
        finally { ObjectFinallyHandler( __SignalEventArg__ ); }
        return this;
        
    }
    
object REFRESH_OnPush_2 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        
        __context__.SourceCodeLine = 252;
        if ( Functions.TestForTrue  ( ( ENABLED  .Value)  ) ) 
            { 
            __context__.SourceCodeLine = 253;
            Trace( "refreshing amp status") ; 
            __context__.SourceCodeLine = 254;
            GETSTATUS (  __context__  ) ; 
            } 
        
        else 
            { 
            __context__.SourceCodeLine = 256;
            Trace( "The KDA connection is disabled, ignoring refresh") ; 
            } 
        
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object LED_FLASH_OnPush_3 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        
        __context__.SourceCodeLine = 261;
        SENDCOMMAND (  __context__ , "LEDF ON") ; 
        __context__.SourceCodeLine = 262;
        LED_FLASH_FB  .Value = (ushort) ( 1 ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object LED_FLASH_OnRelease_4 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        
        __context__.SourceCodeLine = 266;
        SENDCOMMAND (  __context__ , "LEDF OFF") ; 
        __context__.SourceCodeLine = 267;
        LED_FLASH_FB  .Value = (ushort) ( 0 ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object MUTE_OnPush_5 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        ushort CHANNEL_NUMBER = 0;
        ushort STATUS = 0;
        
        CrestronString TX__DOLLAR__;
        TX__DOLLAR__  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 16, this );
        
        
        __context__.SourceCodeLine = 274;
        CHANNEL_NUMBER = (ushort) ( Functions.GetLastModifiedArrayIndex( __SignalEventArg__ ) ) ; 
        __context__.SourceCodeLine = 275;
        MakeString ( TX__DOLLAR__ , "MUTE CH{0:d} ON", (ushort)CHANNEL_NUMBER) ; 
        __context__.SourceCodeLine = 277;
        Trace( "enabling mute on channel {0:d}", (ushort)CHANNEL_NUMBER) ; 
        __context__.SourceCodeLine = 279;
        STATUS = (ushort) ( SENDCOMMAND( __context__ , TX__DOLLAR__ ) ) ; 
        __context__.SourceCodeLine = 280;
        MUTE_FB [ CHANNEL_NUMBER]  .Value = (ushort) ( 1 ) ; 
        __context__.SourceCodeLine = 282;
        if ( Functions.TestForTrue  ( ( Functions.BoolToInt (STATUS != 0))  ) ) 
            { 
            __context__.SourceCodeLine = 283;
            Trace( "Error Sending to KDA: {0:d}\r\n", (short)STATUS) ; 
            } 
        
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object MUTE_OnRelease_6 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        ushort CHANNEL_NUMBER = 0;
        ushort STATUS = 0;
        
        CrestronString TX__DOLLAR__;
        TX__DOLLAR__  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 16, this );
        
        
        __context__.SourceCodeLine = 291;
        CHANNEL_NUMBER = (ushort) ( Functions.GetLastModifiedArrayIndex( __SignalEventArg__ ) ) ; 
        __context__.SourceCodeLine = 292;
        MakeString ( TX__DOLLAR__ , "MUTE CH{0:d} OFF", (ushort)CHANNEL_NUMBER) ; 
        __context__.SourceCodeLine = 294;
        Trace( "disabling mute on channel {0:d}", (ushort)CHANNEL_NUMBER) ; 
        __context__.SourceCodeLine = 296;
        STATUS = (ushort) ( SENDCOMMAND( __context__ , TX__DOLLAR__ ) ) ; 
        __context__.SourceCodeLine = 297;
        MUTE_FB [ CHANNEL_NUMBER]  .Value = (ushort) ( 0 ) ; 
        __context__.SourceCodeLine = 299;
        if ( Functions.TestForTrue  ( ( Functions.BoolToInt (STATUS != 0))  ) ) 
            { 
            __context__.SourceCodeLine = 300;
            Trace( "Error Sending to KDA: {0:d}\r\n", (short)STATUS) ; 
            } 
        
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object CHANNEL_OnChange_7 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        ushort CHANNEL_NUMBER = 0;
        ushort SOURCE = 0;
        ushort STATUS = 0;
        
        CrestronString TX__DOLLAR__;
        TX__DOLLAR__  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 16, this );
        
        
        __context__.SourceCodeLine = 309;
        CHANNEL_NUMBER = (ushort) ( Functions.GetLastModifiedArrayIndex( __SignalEventArg__ ) ) ; 
        __context__.SourceCodeLine = 310;
        SOURCE = (ushort) ( CHANNEL[ CHANNEL_NUMBER ] .UshortValue ) ; 
        __context__.SourceCodeLine = 312;
        Trace( "Source for channel {0:d} has changed to {1:d}", (ushort)CHANNEL_NUMBER, (ushort)SOURCE) ; 
        __context__.SourceCodeLine = 314;
        if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( (Functions.TestForTrue ( Functions.BoolToInt ( SOURCE < 1 ) ) || Functions.TestForTrue ( Functions.BoolToInt ( SOURCE > 12 ) )) ))  ) ) 
            { 
            __context__.SourceCodeLine = 315;
            Trace( "The source must be between 1 and 12") ; 
            } 
        
        else 
            { 
            __context__.SourceCodeLine = 317;
            MakeString ( TX__DOLLAR__ , "INP CH{0:d} {1}", (ushort)CHANNEL_NUMBER, INPUTS__DOLLAR__ [ SOURCE ] ) ; 
            __context__.SourceCodeLine = 318;
            STATUS = (ushort) ( SENDCOMMAND( __context__ , TX__DOLLAR__ ) ) ; 
            __context__.SourceCodeLine = 320;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (STATUS != 0))  ) ) 
                { 
                __context__.SourceCodeLine = 321;
                Trace( "Error Sending to KDA: {0:d}\r\n", (short)STATUS) ; 
                } 
            
            else 
                { 
                __context__.SourceCodeLine = 323;
                MakeString ( TX__DOLLAR__ , "INP CH{0:d}?", (ushort)CHANNEL_NUMBER) ; 
                __context__.SourceCodeLine = 324;
                STATUS = (ushort) ( SENDCOMMAND( __context__ , TX__DOLLAR__ ) ) ; 
                } 
            
            } 
        
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object VOLUME_OnChange_8 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        ushort CHANNEL_NUMBER = 0;
        ushort VOL = 0;
        
        short SCALED_VOLUME = 0;
        short TEMP = 0;
        
        CrestronString TX__DOLLAR__;
        TX__DOLLAR__  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 32, this );
        
        
        __context__.SourceCodeLine = 334;
        CHANNEL_NUMBER = (ushort) ( Functions.GetLastModifiedArrayIndex( __SignalEventArg__ ) ) ; 
        __context__.SourceCodeLine = 335;
        VOL = (ushort) ( VOLUME[ CHANNEL_NUMBER ] .UshortValue ) ; 
        __context__.SourceCodeLine = 340;
        Trace( "scaled: {0:d}", (short)(((VOL / 100) * Functions.ToInteger( -( 40 ) )) / 655)) ; 
        __context__.SourceCodeLine = 341;
        SCALED_VOLUME = (short) ( (TEMP / 655) ) ; 
        __context__.SourceCodeLine = 342;
        MakeString ( VOLUME__DOLLAR___FB [ CHANNEL_NUMBER] , "-{0:d2} dB", (short)(SCALED_VOLUME + RANGE  .Value)) ; 
        __context__.SourceCodeLine = 344;
        Trace( "scaling volume to {0:d} (range is {1:d})", (short)(SCALED_VOLUME + RANGE  .Value), (short)RANGE  .Value) ; 
        __context__.SourceCodeLine = 345;
        MakeString ( TX__DOLLAR__ , "VOL CH{0:d} {1:d2}", (short)CHANNEL_NUMBER, (short)(SCALED_VOLUME + RANGE  .Value)) ; 
        __context__.SourceCodeLine = 346;
        SENDCOMMAND (  __context__ , TX__DOLLAR__) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object KDA_OnSocketReceive_9 ( Object __Info__ )

    { 
    SocketEventInfo __SocketInfo__ = (SocketEventInfo)__Info__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SocketInfo__);
        ushort CH = 0;
        ushort I = 0;
        
        CrestronString RX__DOLLAR__;
        CrestronString COMMAND__DOLLAR__;
        CrestronString CMD__DOLLAR__;
        CrestronString PARAM__DOLLAR__;
        RX__DOLLAR__  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1024, this );
        COMMAND__DOLLAR__  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 512, this );
        CMD__DOLLAR__  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 5, this );
        PARAM__DOLLAR__  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 32, this );
        
        
        __context__.SourceCodeLine = 353;
        RX__DOLLAR__  .UpdateValue ( KDA .  SocketRxBuf  ) ; 
        __context__.SourceCodeLine = 354;
        Functions.ClearBuffer ( KDA .  SocketRxBuf ) ; 
        __context__.SourceCodeLine = 356;
        if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( Functions.Length( RX__DOLLAR__ ) < 256 ))  ) ) 
            {
            __context__.SourceCodeLine = 357;
            Trace( "Rx: {0}", RX__DOLLAR__ ) ; 
            }
        
        __context__.SourceCodeLine = 359;
        COMMAND__DOLLAR__  .UpdateValue ( Functions.Left ( RX__DOLLAR__ ,  (int) ( Functions.Find( "\r" , RX__DOLLAR__ ) ) )  ) ; 
        __context__.SourceCodeLine = 361;
        CMD__DOLLAR__  .UpdateValue ( Functions.Remove ( " " , COMMAND__DOLLAR__ )  ) ; 
        __context__.SourceCodeLine = 362;
        CH = (ushort) ( Functions.Atoi( Functions.Remove( " " , COMMAND__DOLLAR__ ) ) ) ; 
        __context__.SourceCodeLine = 363;
        PARAM__DOLLAR__  .UpdateValue ( Functions.Left ( COMMAND__DOLLAR__ ,  (int) ( (Functions.Length( COMMAND__DOLLAR__ ) - 1) ) )  ) ; 
        __context__.SourceCodeLine = 365;
        ushort __FN_FORSTART_VAL__1 = (ushort) ( 1 ) ;
        ushort __FN_FOREND_VAL__1 = (ushort)Functions.Length( COMMAND__DOLLAR__ ); 
        int __FN_FORSTEP_VAL__1 = (int)1; 
        for ( I  = __FN_FORSTART_VAL__1; (__FN_FORSTEP_VAL__1 > 0)  ? ( (I  >= __FN_FORSTART_VAL__1) && (I  <= __FN_FOREND_VAL__1) ) : ( (I  <= __FN_FORSTART_VAL__1) && (I  >= __FN_FOREND_VAL__1) ) ; I  += (ushort)__FN_FORSTEP_VAL__1) 
            { 
            __context__.SourceCodeLine = 366;
            Trace( "{0} ({1:d})", Functions.Chr ( Byte( COMMAND__DOLLAR__ , (int)( I ) ) ) , (ushort)Byte( COMMAND__DOLLAR__ , (int)( I ) )) ; 
            __context__.SourceCodeLine = 365;
            } 
        
        __context__.SourceCodeLine = 369;
        Trace( "Incoming command is {0}({1:d}), channel is {2:d} and param is {3}({4:d})", CMD__DOLLAR__ , (ushort)Functions.Length( CMD__DOLLAR__ ), (ushort)CH, PARAM__DOLLAR__ , (ushort)Functions.Length( PARAM__DOLLAR__ )) ; 
        __context__.SourceCodeLine = 371;
        if ( Functions.TestForTrue  ( ( Functions.BoolToInt (CMD__DOLLAR__ == "INP "))  ) ) 
            {
            __context__.SourceCodeLine = 371;
            PARSEINPUT (  __context__ , (ushort)( CH ), PARAM__DOLLAR__) ; 
            }
        
        __context__.SourceCodeLine = 372;
        if ( Functions.TestForTrue  ( ( Functions.BoolToInt (CMD__DOLLAR__ == "VOL "))  ) ) 
            {
            __context__.SourceCodeLine = 372;
            PARSEVOLUME (  __context__ , (ushort)( CH ), PARAM__DOLLAR__) ; 
            }
        
        __context__.SourceCodeLine = 373;
        if ( Functions.TestForTrue  ( ( Functions.BoolToInt (CMD__DOLLAR__ == "MUTE "))  ) ) 
            {
            __context__.SourceCodeLine = 373;
            PARSEMUTE (  __context__ , (ushort)( CH ), PARAM__DOLLAR__) ; 
            }
        
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SocketInfo__ ); }
    return this;
    
}

public override object FunctionMain (  object __obj__ ) 
    { 
    try
    {
        SplusExecutionContext __context__ = SplusFunctionMainStartCode();
        
        __context__.SourceCodeLine = 383;
        INPUTS__DOLLAR__ [ 1 ]  .UpdateValue ( "UNBAL1"  ) ; 
        __context__.SourceCodeLine = 384;
        INPUTS__DOLLAR__ [ 2 ]  .UpdateValue ( "UNBAL2"  ) ; 
        __context__.SourceCodeLine = 385;
        INPUTS__DOLLAR__ [ 3 ]  .UpdateValue ( "UNBAL3"  ) ; 
        __context__.SourceCodeLine = 386;
        INPUTS__DOLLAR__ [ 4 ]  .UpdateValue ( "UNBAL4"  ) ; 
        __context__.SourceCodeLine = 387;
        INPUTS__DOLLAR__ [ 5 ]  .UpdateValue ( "UNBAL12"  ) ; 
        __context__.SourceCodeLine = 388;
        INPUTS__DOLLAR__ [ 6 ]  .UpdateValue ( "UNBAL34"  ) ; 
        __context__.SourceCodeLine = 389;
        INPUTS__DOLLAR__ [ 7 ]  .UpdateValue ( "BAL1"  ) ; 
        __context__.SourceCodeLine = 390;
        INPUTS__DOLLAR__ [ 8 ]  .UpdateValue ( "BAL2"  ) ; 
        __context__.SourceCodeLine = 391;
        INPUTS__DOLLAR__ [ 9 ]  .UpdateValue ( "BAL3"  ) ; 
        __context__.SourceCodeLine = 392;
        INPUTS__DOLLAR__ [ 10 ]  .UpdateValue ( "BAL4"  ) ; 
        __context__.SourceCodeLine = 393;
        INPUTS__DOLLAR__ [ 11 ]  .UpdateValue ( "BAL12"  ) ; 
        __context__.SourceCodeLine = 394;
        INPUTS__DOLLAR__ [ 12 ]  .UpdateValue ( "BAL34"  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler(); }
    return __obj__;
    }
    

public override void LogosSplusInitialize()
{
    SocketInfo __socketinfo__ = new SocketInfo( 1, this );
    InitialParametersClass.ResolveHostName = __socketinfo__.ResolveHostName;
    _SplusNVRAM = new SplusNVRAM( this );
    INPUTS__DOLLAR__  = new CrestronString[ 13 ];
    for( uint i = 0; i < 13; i++ )
        INPUTS__DOLLAR__ [i] = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 8, this );
    KDA  = new SplusUdpSocket ( 1024, this );
    
    ENABLE = new Crestron.Logos.SplusObjects.DigitalInput( ENABLE__DigitalInput__, this );
    m_DigitalInputList.Add( ENABLE__DigitalInput__, ENABLE );
    
    REFRESH = new Crestron.Logos.SplusObjects.DigitalInput( REFRESH__DigitalInput__, this );
    m_DigitalInputList.Add( REFRESH__DigitalInput__, REFRESH );
    
    LED_FLASH = new Crestron.Logos.SplusObjects.DigitalInput( LED_FLASH__DigitalInput__, this );
    m_DigitalInputList.Add( LED_FLASH__DigitalInput__, LED_FLASH );
    
    MUTE = new InOutArray<DigitalInput>( 4, this );
    for( uint i = 0; i < 4; i++ )
    {
        MUTE[i+1] = new Crestron.Logos.SplusObjects.DigitalInput( MUTE__DigitalInput__ + i, MUTE__DigitalInput__, this );
        m_DigitalInputList.Add( MUTE__DigitalInput__ + i, MUTE[i+1] );
    }
    
    ENABLED = new Crestron.Logos.SplusObjects.DigitalOutput( ENABLED__DigitalOutput__, this );
    m_DigitalOutputList.Add( ENABLED__DigitalOutput__, ENABLED );
    
    REFRESHING = new Crestron.Logos.SplusObjects.DigitalOutput( REFRESHING__DigitalOutput__, this );
    m_DigitalOutputList.Add( REFRESHING__DigitalOutput__, REFRESHING );
    
    LED_FLASH_FB = new Crestron.Logos.SplusObjects.DigitalOutput( LED_FLASH_FB__DigitalOutput__, this );
    m_DigitalOutputList.Add( LED_FLASH_FB__DigitalOutput__, LED_FLASH_FB );
    
    MUTE_FB = new InOutArray<DigitalOutput>( 4, this );
    for( uint i = 0; i < 4; i++ )
    {
        MUTE_FB[i+1] = new Crestron.Logos.SplusObjects.DigitalOutput( MUTE_FB__DigitalOutput__ + i, this );
        m_DigitalOutputList.Add( MUTE_FB__DigitalOutput__ + i, MUTE_FB[i+1] );
    }
    
    CHANNEL = new InOutArray<AnalogInput>( 4, this );
    for( uint i = 0; i < 4; i++ )
    {
        CHANNEL[i+1] = new Crestron.Logos.SplusObjects.AnalogInput( CHANNEL__AnalogSerialInput__ + i, CHANNEL__AnalogSerialInput__, this );
        m_AnalogInputList.Add( CHANNEL__AnalogSerialInput__ + i, CHANNEL[i+1] );
    }
    
    VOLUME = new InOutArray<AnalogInput>( 4, this );
    for( uint i = 0; i < 4; i++ )
    {
        VOLUME[i+1] = new Crestron.Logos.SplusObjects.AnalogInput( VOLUME__AnalogSerialInput__ + i, VOLUME__AnalogSerialInput__, this );
        m_AnalogInputList.Add( VOLUME__AnalogSerialInput__ + i, VOLUME[i+1] );
    }
    
    CHANNEL_FB = new InOutArray<AnalogOutput>( 4, this );
    for( uint i = 0; i < 4; i++ )
    {
        CHANNEL_FB[i+1] = new Crestron.Logos.SplusObjects.AnalogOutput( CHANNEL_FB__AnalogSerialOutput__ + i, this );
        m_AnalogOutputList.Add( CHANNEL_FB__AnalogSerialOutput__ + i, CHANNEL_FB[i+1] );
    }
    
    VOLUME_FB = new InOutArray<AnalogOutput>( 4, this );
    for( uint i = 0; i < 4; i++ )
    {
        VOLUME_FB[i+1] = new Crestron.Logos.SplusObjects.AnalogOutput( VOLUME_FB__AnalogSerialOutput__ + i, this );
        m_AnalogOutputList.Add( VOLUME_FB__AnalogSerialOutput__ + i, VOLUME_FB[i+1] );
    }
    
    VOLUME__DOLLAR___FB = new InOutArray<StringOutput>( 4, this );
    for( uint i = 0; i < 4; i++ )
    {
        VOLUME__DOLLAR___FB[i+1] = new Crestron.Logos.SplusObjects.StringOutput( VOLUME__DOLLAR___FB__AnalogSerialOutput__ + i, this );
        m_StringOutputList.Add( VOLUME__DOLLAR___FB__AnalogSerialOutput__ + i, VOLUME__DOLLAR___FB[i+1] );
    }
    
    PORT = new UShortParameter( PORT__Parameter__, this );
    m_ParameterList.Add( PORT__Parameter__, PORT );
    
    RANGE = new UShortParameter( RANGE__Parameter__, this );
    m_ParameterList.Add( RANGE__Parameter__, RANGE );
    
    IPADDRESS = new StringParameter( IPADDRESS__Parameter__, this );
    m_ParameterList.Add( IPADDRESS__Parameter__, IPADDRESS );
    
    
    ENABLE.OnDigitalPush.Add( new InputChangeHandlerWrapper( ENABLE_OnPush_0, false ) );
    ENABLE.OnDigitalRelease.Add( new InputChangeHandlerWrapper( ENABLE_OnRelease_1, false ) );
    REFRESH.OnDigitalPush.Add( new InputChangeHandlerWrapper( REFRESH_OnPush_2, false ) );
    LED_FLASH.OnDigitalPush.Add( new InputChangeHandlerWrapper( LED_FLASH_OnPush_3, false ) );
    LED_FLASH.OnDigitalRelease.Add( new InputChangeHandlerWrapper( LED_FLASH_OnRelease_4, false ) );
    for( uint i = 0; i < 4; i++ )
        MUTE[i+1].OnDigitalPush.Add( new InputChangeHandlerWrapper( MUTE_OnPush_5, false ) );
        
    for( uint i = 0; i < 4; i++ )
        MUTE[i+1].OnDigitalRelease.Add( new InputChangeHandlerWrapper( MUTE_OnRelease_6, false ) );
        
    for( uint i = 0; i < 4; i++ )
        CHANNEL[i+1].OnAnalogChange.Add( new InputChangeHandlerWrapper( CHANNEL_OnChange_7, false ) );
        
    for( uint i = 0; i < 4; i++ )
        VOLUME[i+1].OnAnalogChange.Add( new InputChangeHandlerWrapper( VOLUME_OnChange_8, false ) );
        
    KDA.OnSocketReceive.Add( new SocketHandlerWrapper( KDA_OnSocketReceive_9, false ) );
    
    _SplusNVRAM.PopulateCustomAttributeList( true );
    
    NVRAM = _SplusNVRAM;
    
}

public override void LogosSimplSharpInitialize()
{
    
    
}

public UserModuleClass_KLIPSCH_KDA ( string InstanceName, string ReferenceID, Crestron.Logos.SplusObjects.CrestronStringEncoding nEncodingType ) : base( InstanceName, ReferenceID, nEncodingType ) {}




const uint ENABLE__DigitalInput__ = 0;
const uint REFRESH__DigitalInput__ = 1;
const uint LED_FLASH__DigitalInput__ = 2;
const uint MUTE__DigitalInput__ = 3;
const uint CHANNEL__AnalogSerialInput__ = 0;
const uint VOLUME__AnalogSerialInput__ = 4;
const uint ENABLED__DigitalOutput__ = 0;
const uint REFRESHING__DigitalOutput__ = 1;
const uint LED_FLASH_FB__DigitalOutput__ = 2;
const uint MUTE_FB__DigitalOutput__ = 3;
const uint CHANNEL_FB__AnalogSerialOutput__ = 0;
const uint VOLUME_FB__AnalogSerialOutput__ = 4;
const uint VOLUME__DOLLAR___FB__AnalogSerialOutput__ = 8;
const uint PORT__Parameter__ = 10;
const uint RANGE__Parameter__ = 11;
const uint IPADDRESS__Parameter__ = 12;

[SplusStructAttribute(-1, true, false)]
public class SplusNVRAM : SplusStructureBase
{

    public SplusNVRAM( SplusObject __caller__ ) : base( __caller__ ) {}
    
    
}

SplusNVRAM _SplusNVRAM = null;

public class __CEvent__ : CEvent
{
    public __CEvent__() {}
    public void Close() { base.Close(); }
    public int Reset() { return base.Reset() ? 1 : 0; }
    public int Set() { return base.Set() ? 1 : 0; }
    public int Wait( int timeOutInMs ) { return base.Wait( timeOutInMs ) ? 1 : 0; }
}
public class __CMutex__ : CMutex
{
    public __CMutex__() {}
    public void Close() { base.Close(); }
    public void ReleaseMutex() { base.ReleaseMutex(); }
    public int WaitForMutex() { return base.WaitForMutex() ? 1 : 0; }
}
 public int IsNull( object obj ){ return (obj == null) ? 1 : 0; }
}


}
